;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;               Bambin                                              ;;;;;
;;;;;                                                                   ;;;;;
;;;;;   Mmoire de la tortue                                            ;;;;;
;;;;;       Mose Valvassori  - 08.07.99                                ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;	$Id$	

(display "Mmoire. ")

(define (creer-memoire-tortue tortoise)
  (let ((memoire '()))

    (define (memorise truc)
      (set! memoire (cons truc memoire)))
    (define (rappelle)
      (let ((truc (car memoire)))
	(set! memoire (cdr memoire))
	truc))

    (lambda (mesg . param)
      (case mesg
	((avancer tourner-gauche tourner-droite)
	 (memorise mesg)
	 (tortoise mesg param))

	((memoire) memoire)

	((revenir-en-arriere) 
	 (case (rappelle)
	   ((tourner-droite)
	    (tortoise 'tourner-gauche))
	   ((tourner-gauche)
	    (tortoise 'tourner-droite))
	   ((avancer)
	    (tortoise 'reculer))
	   ((reculer)
	    (tortoise 'avancer))
	   ))
	
	(else (tortoise mesg param))
	))))

(define tortue (creer-memoire-tortue tortue))

(apprendre revenir (tortue 'revenir-en-arriere))


