;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;               Bambin                                              ;;;;;
;;;;;                                                                   ;;;;;
;;;;;   Voir le monde en texte                                          ;;;;;
;;;;;       Mose Valvassori  - 08.07.99                                ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;	$Id: bambin-voir-texte.scm,v 1.1 1999/07/08 19:10:58 djedi Exp djedi $	
(display "Visualisation Texte. ")

(define (creer-affichage-tortue tortue)
    (lambda (mesg . param)
      (case mesg
	((avancer reculer tourner-gauche tourner-droite)
	 (tortue mesg param)
	 (voir-le-monde))	
	(else (tortue mesg param))
	)))

(define tortue (creer-affichage-tortue tortue))


; ==========================================================


(define (voir-le-monde-en-ascii)
  (newline)
  (repeat 
   (- limite-y 1)
   (lambda (y)
     (repeat
      (- limite-x 1)
      (lambda (x)
	(let* ((x (- limite-x x 1))
	       (y (- limite-y y 1))
	       (ici (regarder-dans-le-monde x y)))
	  (cond 
	   ((and (= x (position-tortue-x)) (= y (position-tortue-y))) 
	    (afficher-tortue))
	   ((null? ici) (display ". "))
	   (else (display "X "))
	   )
	  )))
     (newline)
     )))

(define (afficher-tortue)
  (case (direction-tortue)
    ((droite)
     (display "> "))
    ((gauche)
     (display "< "))
    ((bas)
     (display "v "))
    ((haut)
     (display "^ "))
    ))



